#!/usr/bin/env python
# -*- coding: utf8 -*-
'''

Parrot:  The classifier that always says the same thing.  This is useful when
other learners/predictors (looking at you, WEKA) do not support the degenerate
case when all training labels are identical.

Also, it's fast!

Copyright © 2010 Keith Noto.  Disributed under Gnu General Public License (see http://www.gnu.org/licenses/gpl.html).

'''
__author__ = "Keith Noto <noto@cs.tufts.edu>";
__license__ = "GPL";
__copyright__ = "Copyright © 2010 Keith Noto";
VERSION = __revision__ = "1.0";

class Predictor:
	def __init__(self,value,distribution):
		self.value,self.distribution = value,distribution;
	def __call__(self, Q):
		for x in Q:
			yield (self.value,self.distribution) # (prediction,distribution)

class Learner:
	def __init__(self, value):
		self.value = value;
	def __call__(self,(ftypes,ttype),_trainset):
		return Predictor(self.value, map(lambda label : 1.0 if label==self.value else 0.0, ttype) if type(ttype) is list else None)
	def classifier():
		return False

