#!/usr/bin/env python
# -*- coding: utf8 -*-
# Copyright © 2010 Keith Noto.  Disributed under Gnu General Public License (see http://www.gnu.org/licenses/gpl.html).

__author__ = "Keith Noto <noto@cs.tufts.edu>"
__license__ = "GPL"
__copyright__ = "Copyright © 2010 Keith Noto"
VERSION = __revision__ = "1.0"

import string

# Encode a list of integers in a string that can be parsed later 
# [1,2,3,4] -> "1-4"
# [1,2,3, 9,10,11, 14] -> "1-3,9-11,14"
def encode(X):
	ans = ""
	g = None # (last number written to `ans')
	p = None # (previous number in the list)
	m={}
	for x in X:
		m[x]=True
	X = list(sorted(m.keys())) # reduce X to sorted uniq integers
	for i in range(len(X)):
		f = X[i]
		if p is None: # first
			ans = "%d" % (f)
			g=f
		elif f != p+1: # interrupted
			ans = "%s-%d,%d" % ( ans, p, f)   if p>g else "%s,%d" % (ans,f)
			g=f
		elif i == len(X)-1: # last
			ans = "%s-%d" % ( ans, f)
			# g<-f, but g won't be used again
		p = f
	return ans

# Decode a string representing a set of integers
# "1-5,7,9,11-15" -> [1,2,3,4,5,7,9,11,12,13,14,15]
def decode(msg):
	for r in msg.split(','):
		r = r.strip().split('-')
		if len(r)==1:
			yield int(r[0])
		else:
			for x in range(int(r[0]), 1+int(r[-1])):
				yield x

